/*
 * "Hello World" example.
 *
 * This example prints 'Hello from Nios II' to the STDOUT stream. It runs on
 * the Nios II 'standard', 'full_featured', 'fast', and 'low_cost' example
 * designs. It runs with or without the MicroC/OS-II RTOS and requires a STDOUT
 * device in your system's hardware.
 * The memory footprint of this hosted application is ~69 kbytes by default
 * using the standard reference design.
 *
 * For a reduced footprint version of this template, and an explanation of how
 * to reduce the memory footprint for a given application, see the
 * "small_hello_world" template.
 *
 */

#define MAX_INPUT 1024
#include "mmc_header.h"
#include "stdio.h"
#include "fat.h"
#include "jpeg.h"

int input_buf_size =0;

static Volume *v;
static Channel c1d, c2d;
static Channel *c1=&c1d, *c2=&c2d;


int init_file_system( )
{
    unsigned char arg[4] = { 0x00, 0x00, 0x02, 0x00 };
    mmc_super_init(arg);
    send_clks(8,60);
    
    return 0;
}

int mount_file_system( )
{
    int res = 0;
    res = fat_init ("", &v, &c1);
    if (res < 0)
    {
        printf("Mount Error: %i (%s)\n", res, strerror(-res));
        return -1;
    }
    
    return 0;
}

int seek_file( const char * filename, const char * ext, int * size )
{
    if( filename == NULL || ext == NULL || size == NULL )
    {
        return -1;
    }
    
    return 0;
}

static unsigned char * file_buffer = NULL;
const unsigned char * read_next_file( const char * ext, char * filename, int * size )
{
    // check parameters
    if( ext == NULL || filename == NULL || size == NULL )
    {
        return NULL;
    }
    
    // check parameter integrity
    if( strlen( ext ) <= 0 )
    {
        return NULL;
    }
    
    // go to next file
    *size = fat_nextfile( v, c1, &c2, filename);
    if( *size <= 0 )
    {
        return NULL;
    }
    printf( "filename: %s\n", filename );
    
    // check file extension
    char file_ext[ 10 ] = { 0, };
    fat_getfilext( filename, file_ext );
    if( strncmp( file_ext, ext, strlen( file_ext ) ) != 0 )
    {
        return NULL;
    }
    
    // allocate buffer
    if( input_buffer == NULL )
    {
        input_buffer = ( unsigned char * ) malloc( ( * size ) * sizeof( unsigned char ) + 1 );
    }
    if( input_buffer == NULL )
    {
        return NULL;
    }
    
    // read file
    input_buf_size = *size;
    input_buffer[ *size ] = -1;
    int res = 0;
    res = fat_read( c2, input_buffer, *size );
    if( res < 0 )
    {
        free( input_buffer );
        input_buffer = NULL;
        return NULL;
    }
    
    return input_buffer;
    
}

void fat_loop_files()
{
    
  //printf ("Inside fat loop\n");
unsigned int image_counting=0;
  unsigned char arg[4] = { 0x00, 0x00, 0x02, 0x00 };
  mmc_super_init(arg);
  send_clks(8,60);
  
 // do
  {
    
    int res, size;//, i, j;
    char filename[13];
	char ext[4];
    char buffer[512];

        res = fat_init ("", &v, &c1);
        if (res < 0) {
                printf("Mount Error: %i (%s)\n", res, strerror(-res));
                return 0;
        }

        //loop thru all files in the root directory
        while((size = fat_nextfile(v, c1, &c2, filename)) >= 0 && image_counting < 8 ) {
        	printf("filename = %s, size=%d\n", filename, size);
			fat_getfilext(filename, ext);
          {
			if (strncmp(ext, "JPG", 3) == 0) {
                  //printf("JPEG Found!\n");
                  input_buffer = (unsigned char*) malloc (size * sizeof(unsigned char) + 1);
                  if(input_buffer == NULL)
                  {
                    printf("\nError in allocating memory for input buffer\n");   
                  }
           	        //  if small file, print it's contents
       		         //if (size < 512) {
                           input_buf_size = size;
                           input_buffer[size] = -1;
                           int  read =0;
                           //while(read < size)
                           //{
                           
                           //int a;
                           //char *b = malloc(100000);
                           //printf("Stack = %d, Heap=%d\n", &a, b);
                           //free(b);
              	         	res = fat_read(c2, input_buffer+read, size);
                            //printf ("Bytes read = %d, total=%d \n", res, res); 
                            if (res < 0) {
                                printf("Read error: %i (%s)\n", res, strerror(-res));
                                //break;
                            }
                            //read += res;
                           //} //end while
                       
               	       	  
                	        if (res >= 0)
                             {
                                
                           
                                   
                                  //  for(i=0; i<size; i++)
                                 // printf("%d\n", input_buffer[i]);
                                  //printf ("Before Decoding\n");
                                 
                                    //exit (1);
                                  jpeg_decoder();
                                  image_counting= image_counting+1; 
                           }
                           else 
                            free (input_buffer);
                      
                	//}
			}
            
        }
// 
  
    
}

 }
 //while(1);
}

